#ifndef Model_H
#define Model_H

#include "stdafx.h"
#include <windows.h>
#include "Thread.h"
#include "View.h"
#include "SyncronousAutomaton.h"
#include  "valores.h"

class Model : public CThread{
	
	SyncronousAutomaton<int> *automaton2d;
	
public:
	
	void ThreadCtor(){ 
		init(); 
		printf("model  constructor----------------------------- \n");
		
		automaton2d = new SyncronousAutomaton<int>
		(&statesMatrix[0][0][0], &statesMatrixnt1[0][0][0], dimSizes2D, dimencions2D); 
		automaton2d->iterateOverTheSatesArray();
		printf("fin model  constructor----------------------------- \n");
		
	}
	~Model(){}
	virtual DWORD Run( LPVOID arg ){
		printf("model  antes de wile----------------------------- \n");
		int plusOne;
		bool flag = false;
		while(1)
        {
           // Sleep(30);//y por ultimo los colores

			////////////RULE/////////////////////////////
			flag = false;
			for(int i = 0; i < xmax*ymax*zmax; ++i){
				plusOne = *(automaton2d->graph[i].centerCell) + 1;
				if(plusOne == states)
					plusOne = 0;
				for(int j = automaton2d->graph[i].beginNeighbor; j <= automaton2d->graph[i].endNeighbor; ++j){
					if(*(automaton2d->neighbors[j]) == plusOne){
						*(automaton2d->graph[i].centerCellTPlusOne) = plusOne;
						flag = true;
						break;
					}
				}
				if(!flag)
					*(automaton2d->graph[i].centerCellTPlusOne) = *(automaton2d->graph[i].centerCell);
			}
			///////////////RULE///////////////////////////////

			/*sicronize*/
			for(int i = 0; i < xmax*ymax*zmax; ++i)
			*(automaton2d->graph[i].centerCell) = *(automaton2d->graph[i].centerCellTPlusOne);
			
			//update view
			View::cambia();
			//printf("model ----------------------------- \n");
		}
		
		return 0;
	}
};

#endif //Model_H